/*
* CURSOR.C - Position the cursor on the screen.
*
*
* PROGRAMMER:	    Martti Ylikoski
* CREATED:	    29.11.1990
* VERSION:	    1.1
*
*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <param.h>
#include <paramstd.h>

#define INCL_VIO
#include <os2.h>

static char *progname ;

extern unsigned long pflags ;

ParamEntry pentry[12] = {
     "P", &ParamSetPause, 0,
     "F", &ParamSetFold, 0,
     "V", &ParamSetVerbose, 0,
     "R", &ParamSetReport, 0,
     "S", &ParamSetSubDirs, 0,
     "?", &ParamSetHelp, 1,
     "H", &ParamSetHelp, 1,
     "NOD", &ParamSetNoDefault, 0,
     "TEST", &ParamSetTest, 0,
     "Y", &ParamSetYes, 0,
     "N", &ParamSetTest, 0,
     "\0", NULL, 0
} ;

ParamBlock params = {
    "/-",   IGNORECASE | NOPRIORITY | NOTRIGGERSALLOWED ,
    pentry
} ;

int main(int argc, char *argv[])
{
int row, col, i ;

   progname = argv[0] ;

   ParamHandle(&params, &argc, argv) ;

   if (argc < 3 || pflags & PA_HELP)
   {
      printf("usage: %s row col [text] \n", progname) ;
      return( 1 ) ;
   }

   row = atoi(argv[1]) ;
   col = atoi(argv[2]) ;

   VioSetCurPos(row, col, 0) ;

   for (i = 3; i<argc ; i++)
      puts(argv[i]) ;

   return( 0 ) ;
}
